package universum.bi;

/**
 *
 * @author nike
 */
public final class BeingParams implements Cloneable {  
    // mass
    // how much enegry being can hold, but bigger capacity means more
    // energy consumption during moving and living
    public float M;
    // speed
    // how fast being can move, but faster moving means higher energy 
    // spending even during short moves
    public float S;
    // parameter, can be used for customization of new beings
    // as newly created being receives its BeingParams (an argument to
    // ACTION_BORN is passed as an argument for BEING_BORN)
    public Object parameter;    
    
    public BeingParams(float mass, float speed) {
        this(mass, speed, null);
    }
    
    public BeingParams(float mass, float speed, Object parameter) {
        this.M = mass; this.S = speed; this.parameter = parameter;
    }
    
    public BeingParams clone() {
        BeingParams o = null;
        try {
            o = (BeingParams)super.clone();
        } catch (CloneNotSupportedException cnse) {}
        return o;
    }
    
    public String toString() {
        return "[m="+M+" s="+S+"]";
    }
}
