package universum.bi;

import universum.engine.BasicEvent;

/**
 *
 * @author nike
 */
public final class Event extends BasicEvent<Object>
 {
    private EventKind kind;
    
    public Event(EventKind kind) {
       this(kind, null);
    }
    
    public Event(EventKind kind, Object param) {
        this(kind, null, param);          
    }
    
    public Event(EventKind kind, Integer target, Object param) {
        super(param, target);
        this.kind = kind;
    }    
    
    public EventKind kind() {
        return this.kind;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("EVENT: kind=");
        sb.append(kind.toString());
        sb.append(" param=");       
        sb.append(param() == null ? "<null>" : param().toString());
        return sb.toString();
    }       
    
    public Event clone() {
        Constants.checkPerms();
        Event o = null;
        try {
            o = (Event)super.clone();
        } catch (CloneNotSupportedException cnse) {}
        return o;
    }

    
}
