package universum.engine;

import java.util.List;
import java.util.Map;

import universum.bi.*;
import universum.util.Walker;

public interface RenderingInfo {
    // those are to get information on universe parameters   

    // current game status
    public int getStatus();

    // owner's name
    public String          getOwner(Integer beingId);

    // integer ID of owner
    public int             getOwnerId(Integer beingId);
    
    // where this being is
    public Location        getLocation(Integer beingId);    

    // how much energy this being has
    public float           getEnergy(Integer id);
    
    // current turn number
    public int             numTurns();
    
    // total numer of turns
    public int             maxTurns();

    // how much energy this particular location has
    public float           getResourceCount(Location loc);
    
    // playfield dimensions, for representation on the screen
    public List<Integer>   diameters();

    // visit all points where beings are
    public void forAllE(Walker<Integer> what);
    
    // visit all points where energy is
    public void forAllR(Walker<Location> what);

    // returns scores table
    public Map<String,ScoreData> scores();

    // returns unique ID of the player
    public String nameById(int num);
}
