package universum.ui;

import universum.engine.ScoreData;
import universum.bi.GameKind;
import java.util.*;

public final class GameResult {
    private List<ScoreData> results;
    private int numTurns;
    private GameKind gameKind;

    public GameResult(Map<String,ScoreData> scores, 
                      int numTurns, GameKind gameKind) {
        results = new ArrayList<ScoreData>(scores.values());
        Collections.sort(results);
        this.numTurns = numTurns; 
        this.gameKind = gameKind;
    }

    public ScoreData winner() {
        if (results.size() > 0) {
            ScoreData rv = results.get(0);
            return rv.alive ? rv : null;
        }
        return null;
    }

    public List<ScoreData> results() {
        return this.results;
    }

    public String toString() {
        if (winner() == null) {
            return ">>> Noone survived <<<\n";
        } else {
            StringBuffer result = new StringBuffer();
            for (ScoreData sd: results) {
                result.append(sd.player);
                result.append(":\t\t");
                result.append((int)sd.score);
                result.append("\t\t");
                result.append((int)sd.energy);
                result.append("\n");
            }
            return result.toString();
        }
    }

    public int numTurns() {
        return this.numTurns;
    }

    public GameKind kind() {
        return this.gameKind;
    }
}
