package universum.util;

import java.util.*;
import javax.swing.JOptionPane;
import java.io.InputStream;
import java.net.URL;

import universum.bi.Constants;

/**
 *
 * @author nike
 */
public class Util {
    static Random gen;

    static Random gen() {
	if (gen == null) {
	    // make it somewhat deterministic for debug    
	    gen = Constants.getDebug() ? new Random(10) : new Random();
	}
	return gen;
    }
    
    // return int in interval [0, max)
    public static int rnd(int max) {
        return gen().nextInt(max);
    }
    
    // return int in interval [min, max)    
    public static int rnd(int min, int max) {
        return min + rnd(max-min);
    }
    
    // returns float in interval [0, 1)
    public static float frnd() {
        return gen().nextFloat();
    }
    
    // returns float in interval [0, max)
    public static float frnd(float max) {
        return frnd()*max;
    }
    
    // returns float random in interval [min, max)
    public static float frnd(float min, float max) {
        return min + frnd(max-min);
    }
    // iterates over collection and invoke walker's walk() upone every element
    // Note that collection's lock should be held by owner
    public static <E> void walkList(Collection<E> list, Walker<E> walker) {
        for (E e : list) {
            walker.walk(e);
        }
    }

    public static void sleep(long millis) {
	try {
	    Thread.sleep(millis); 
	} catch (Exception e) {}
    }

    public static void messageBox(String title, String message) {
        JOptionPane.showMessageDialog(null,
                                      message,
                                      title,
                                      JOptionPane.INFORMATION_MESSAGE);
    }


    public static InputStream findResourceAsStream(String name) {
        InputStream is = Util.class.getResourceAsStream("/resources/"+name);
        if (is == null) {
            is = Util.class.getResourceAsStream("/resources/resources/"+name);
        }
        return is;
    }

    public static URL findResource(String name) {
        URL u = Util.class.getResource("/resources/"+name);
         if (u == null) {
            u = Util.class.getResource("/resources/resources/"+name);
        }
        return u;
    }

    public static ResourceBundle findBundle(String name) {
        ResourceBundle rb = null;
        try {
            rb = ResourceBundle.getBundle("resources/"+name);
        } catch (MissingResourceException mre) {
            rb = ResourceBundle.getBundle("resources/resources/"+name);
        }
        return rb;
    }
}
